﻿using Infragistics.Controls.Editors;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace XamSliderOverlapThumbCase
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        double overlapValue = 0;   
        

        private void LowThumb_DragCompleted(object sender, System.Windows.Controls.Primitives.DragCompletedEventArgs e)
        {
            XamSliderNumericThumb XSNT = sender as XamSliderNumericThumb;
            if (XSNT.Value == Slider1.Thumbs[1].Value)
            {
                XSNT.Visibility = Visibility.Collapsed;
                Slider1.Thumbs[1].Visibility = Visibility.Collapsed;

                XSNT.InteractionMode = SliderThumbInteractionMode.Free;
                Slider1.Thumbs[1].InteractionMode = SliderThumbInteractionMode.Free;

                Slider1.Thumbs[2].Visibility = Visibility.Visible;

                Slider1.Thumbs[2].Value = XSNT.Value;

                overlapValue = XSNT.Value;
            }
        }

        private void HighThumb_DragCompleted(object sender, System.Windows.Controls.Primitives.DragCompletedEventArgs e)
        {
            XamSliderNumericThumb XSNT = sender as XamSliderNumericThumb;
            if (XSNT.Value == Slider1.Thumbs[0].Value)
            {
                XSNT.Visibility = Visibility.Collapsed;
                Slider1.Thumbs[0].Visibility = Visibility.Collapsed;

                XSNT.InteractionMode = SliderThumbInteractionMode.Free;
                Slider1.Thumbs[0].InteractionMode = SliderThumbInteractionMode.Free;

                Slider1.Thumbs[2].Visibility = Visibility.Visible;

                Slider1.Thumbs[2].Value = XSNT.Value;

                overlapValue = XSNT.Value;
            }
        }

        private void OverlapThumb_DragCompleted(object sender, System.Windows.Controls.Primitives.DragCompletedEventArgs e)
        {
            XamSliderNumericThumb XSNT = sender as XamSliderNumericThumb;
            if (XSNT.Value > overlapValue)
            {
                Slider1.Thumbs[1].Value = XSNT.Value;

                Slider1.Thumbs[1].Visibility = System.Windows.Visibility.Visible;
                Slider1.Thumbs[0].Visibility = System.Windows.Visibility.Visible;

                Slider1.Thumbs[1].InteractionMode = SliderThumbInteractionMode.Lock;
                Slider1.Thumbs[0].InteractionMode = SliderThumbInteractionMode.Lock;

                XSNT.Visibility = Visibility.Collapsed;
            }
            else if (XSNT.Value < overlapValue)
            {
                Slider1.Thumbs[0].Value = XSNT.Value;

                Slider1.Thumbs[0].Visibility = System.Windows.Visibility.Visible;
                Slider1.Thumbs[1].Visibility = System.Windows.Visibility.Visible;

                Slider1.Thumbs[1].InteractionMode = SliderThumbInteractionMode.Lock;
                Slider1.Thumbs[0].InteractionMode = SliderThumbInteractionMode.Lock;

                XSNT.Visibility = Visibility.Collapsed;
            }           
        }

        private void OverlapThumb_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            XamSliderNumericThumb XSNT = sender as XamSliderNumericThumb;
            Slider1.Thumbs[0].Visibility = Visibility.Visible;
            Slider1.Thumbs[1].Visibility = Visibility.Visible;            
        }  
    }
}
